#include "letadla.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

tabule::tabule() {
   tabule(5);  // implicitne nastav pocet zobraovanych zaznamu na pet
}

tabule::tabule(int p) {
   prvni= NULL; // inicializace
   kolik= p;
}

tabule::~tabule() {
	smazvse();
}

int tabule::smazvse() {
   let *next;
// smaz cely seznam
	while(prvni) {
   	next= prvni;
      prvni= prvni->dalsi;
      free(next);
   }
   prvni=NULL;
   return 1;
}

int tabule::vloz(zaznam z) {
	if(z.num < 1)
   	return 0; // chyba let nemuze mit cislo mensi nez 1
   if(prvni==NULL) {  // pokud nic nebylo vlozeno
      if((prvni= (let *) malloc(sizeof(let)))==NULL)	// vytvor prvek seznamu
         return 0; // chyba
      prvni->data= z;	//	uloz do nej informace
      prvni->dalsi= NULL;
      return 1; // dobre
   }

	let *next=prvni;
   while(next) {	// projdi seznam...
   	if(next->data.num == z.num)	// ...jestli neobsahuje uz let
      	return 0; //chyba
      next= next->dalsi;
   }
   next= prvni;
   long cas_odletu= z.zpozdeni + z.odlet.minuta + 60*z.odlet.hodina + 60*24*z.odlet.den + 60*24*31*z.odlet.mesic + 60*24*31*12*z.odlet.rok; // vypocti cas odletu
   if(cas_odletu < (next->data.zpozdeni + next->data.odlet.minuta + 60*next->data.odlet.hodina + 60*24*next->data.odlet.den + 60*24*31*next->data.odlet.mesic + 60*24*31*12*next->data.odlet.rok)) { // pokud patri na zacatek...
	   let *novy;
   	if((novy = (let *) malloc(sizeof(let)))== NULL) // vytvor prvek seznamu
   		return 0; // chyba
   	novy->data = z;	// uloz do nej informace
	   novy->dalsi = prvni; // a zarad
   	prvni= novy;	// aktualizuj ukzatel
		return 1; // dobre
	}
   // zarad na spravne misto
   while(next->dalsi && (cas_odletu > (next->dalsi->data.zpozdeni + next->dalsi->data.odlet.minuta + 60*next->dalsi->data.odlet.hodina + 60*24*next->dalsi->data.odlet.den + 60*24*31*next->dalsi->data.odlet.mesic + 60*24*31*12*next->dalsi->data.odlet.rok)))
      next=next->dalsi;

   let *novy;
   if((novy = (let *) malloc(sizeof(let)))== NULL) // vytvor prvek seznamu
   	return 0; // chyba
   novy->data = z;	// uloz do nej informace
   novy->dalsi = next->dalsi;	//	a zarad
   next->dalsi= novy;
	return 1; // dobre
}

int tabule::zpozdi(int l,int cas) {
	if(cas < 0)	// zpozdeni nemuze byt zaporne
   	return 0; //chyba
	let *next=prvni;
   while(next && (next->data.num != l)) // najdi odpovidajici let
   	next= next->dalsi;
   if(next==NULL)	// nenasel jsem ho
   	return 0; //chyba
   (next->data.zpozdeni) += cas; // zpozdi
   long cas_odletu= next->data.zpozdeni + next->data.odlet.minuta + 60*next->data.odlet.hodina + 60*24*next->data.odlet.den + 60*24*31*next->data.odlet.mesic + 60*24*31*12*next->data.odlet.rok; // vypocitej novy cas odletu
   while(next->dalsi && (cas_odletu > (next->dalsi->data.zpozdeni + next->dalsi->data.odlet.minuta + 60*next->dalsi->data.odlet.hodina + 60*24*next->dalsi->data.odlet.den+ 60*24*31*next->dalsi->data.odlet.mesic + 60*24*31*12*next->dalsi->data.odlet.rok))) {  // a zarad zpozdeny let kam patri podle casu
   	zaznam pom= next->data;	// vymen zaznamy
      next->data= next->dalsi->data;
      next= next->dalsi;
      next->data= pom;
   }
   return 1; // dobre
}

zaznam *tabule::get(int l) {
	let *next=prvni;
	while(next && (next->data.num != l))	// najdi odpovidajici let
   	next= next->dalsi;
	if(next==NULL)	// nenasel jsem ho
   	return NULL; // chyba
   return &(next->data);	// vrat zaznam o letu
}

zaznam *tabule::getbypos(int pos) {
	let *next=prvni;
	for(int i=1;i<pos;i++)	// najdi odpovidajici let
   	if(next->dalsi)
	   	next=next->dalsi;
      else
      	return NULL; // neni tolik zaznamu
   return &(next->data);	// vrat zaznam o letu
}

int tabule::vyjmi(int l) {
   if(!prvni)
      return 0; // chyba v sezmamu nic neni
   if(prvni->data.num == l) {	// pokud to je prvni let
      let *pom=prvni;
		prvni= prvni->dalsi;	// u[rav seznam
      free(pom);	// smaz let
      return 1;
   }
	let *next=prvni, *pom;
	while(next->dalsi && (next->dalsi->data.num != l)) // najdi odpovidajici let
   	next= next->dalsi;
	if(next->dalsi==NULL)	// takovy let tam neni
   	return 0; // chyba
   pom=next->dalsi;
   next->dalsi= next->dalsi->dalsi;	// uprav seznam
   free(pom);	// smaz let
   return 1;
}

int tabule::setpocet(int p) {
	if(p<=0)	// pocet vypisovanych prvku nemuze byt mensi nez nula
   	return 0; //chyba
   return kolik=p; // uprav udaje
}

int tabule::zmen(zaznam z) {
	if(!vyjmi(z.num)) // nejdriv vymaz stary
   	return 0; // chyba
   return vloz(z);	// a vloz novy na odpovidajici misto
}

int tabule::najdi(PARRAY *pole,char *kam) {
	let *next=prvni;
   int *pom;
   int i=0;
   while(next) {	// projdi seznam...
      if(strcmpi(next->data.kam,kam)==0) //... a napoctej kolik letu odpovida
      	i++;
   	next= next->dalsi;
   }
   next=prvni;
   if((*pole=pom=(int *)malloc(i*sizeof(int)))==NULL) // vyhrad pamet pro seznam vracenych letu
   	return 0; //chyba
   while(next) { // projdi seznam letu
      if(strcmpi(next->data.kam,kam)==0) { // a zarad odpovidajici do seznamu vracenych letu
         *pom=next->data.num;
         pom++;
      }
   	next= next->dalsi;
   }
   return i; // vrat seznam odpovidajicich letu
}

int tabule::najdi(PARRAY *pole,cas time) {
	let *next=prvni;
   int *pom;
   int i=0;
   while(next) { // projdi seznam letu..
      if((next->data.odlet.rok==time.rok) && (next->data.odlet.mesic==time.mesic) && (next->data.odlet.den==time.den) && (next->data.odlet.hodina==time.hodina) && (next->data.odlet.minuta==time.minuta))
      	i++; // spocitej kolik se bude vracet odpovidajicich letu
   	next= next->dalsi;
   }
   next=prvni;
   if((*pole=pom=(int *)malloc(i*sizeof(int)))==NULL) // vyhrad pamet pro seznam vracenych letu
   	return 0; //chyba
   while(next) {
      if((next->data.odlet.rok==time.rok) && (next->data.odlet.mesic==time.mesic) && (next->data.odlet.den==time.den) && (next->data.odlet.hodina==time.hodina) && (next->data.odlet.minuta==time.minuta)) {
         *pom=next->data.num; // zapisuj odpovidajici lety do seznamu
         pom++;
      }
   	next= next->dalsi;
   }
   return i; // vrat seznam odpovidajicich letu
}

int tabule::najdi(PARRAY *pole,int gate) {
	let *next=prvni;
   int *pom;
   int i=0;
   while(next) { // projdi seznam vsech letu
      if(next->data.brana == gate)
      	i++; // spocitej kolik odpovidajicich letu se bude vracet
   	next= next->dalsi;
   }
   next=prvni;
   if((*pole=pom=(int *)malloc(i*sizeof(int)))==NULL) // vyhrad pamet pro seznam vracenych letu
   	return 0; //chyba
   while(next) {
      if(next->data.brana == gate) { // odpovidajici lety zapisuj do seznamu vracenych letu
         *pom=next->data.num;
         pom++;
      }
   	next= next->dalsi;
   }
   return i; // vrat seznamodpovidajicich letu
}

int tabule::najdi(PARRAY *pole) {
	let *next=prvni;
   int *pom;
   int i=0;
   while(next) { // projdi seznam vsech letu
      if(next->data.zpozdeni > 0) // spocitej kolik se bude vracet odpovidajicich letu
      	i++;
   	next= next->dalsi;
   }
   next=prvni;
   if((*pole=pom=(int *)malloc(i*sizeof(int)))==NULL) // vyhrad pamet pro vraceny seznam
   	return 0; //chyba
   while(next) {
      if(next->data.zpozdeni > 0) { // zapis do seznamu odpovidajici let
         *pom=next->data.num;
         pom++;
      }
   	next= next->dalsi;
   }
   return i; // vrat seznam odpovidajicich letu
}

int tabule::vypis(PARRAY *pole) {
	let *next=prvni;
   int *pom,j=0;
   if((*pole=pom=(int *)malloc((kolik)*sizeof(int)))==NULL)	// vyhrad pamet pro vraceny seznam
   	return 0; //chyba
   for(int i=0;i<kolik;i++) { // projdi zacatek seznamu letu
      if(next) { // a zapisuj je do seznamu vracenych letu
         *pom=next->data.num;
	     	next= next->dalsi;
         j++;
      }
      pom++;
   }
   return j; // vrat pocet skutecne vracenych letu
}

int tabule::uloz(char name[255]) {
  FILE *File;
  if((File=fopen(name,"wb"))==NULL)
    return 0;
  let *next=prvni;
  while(next) {
    if(!fwrite(&(next->data),sizeof(zaznam),1,File)) {
      fclose(File);
      return 0;
    }
    next=next->dalsi;
  }
  fclose(File);
  return 1;
}

int tabule::nahraj(char name[255]) {
  FILE *File;
  if((File=fopen(name,"rb"))==NULL)
    return 0;
  smazvse();
  zaznam z;
  while(!feof(File)) {
    if(!fread(&z,sizeof(zaznam),1 ,File)) {
      fclose(File);
      return 0;
    }
    vloz(z);
  }
  fclose(File);
  return 1;
}
